"""
/***************************************************************************
 SymbolsToolboxDockWidget
                                 A QGIS plugin
 Gestion du patrimoine éclairage public
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                             -------------------
        begin                : 2019-12-04
        git sha              : $Format:%H$
        copyright            : (C) 2019 by Jean-Marie Arsac
        email                : jmarsac@azimut.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os

from qgis.core import QgsProject
from qgis.PyQt import QtWidgets, uic
from qgis.PyQt.QtCore import pyqtSignal
from qgis.PyQt.QtGui import QIcon

from lumigis.place_point_oriented_tool import PlacePointOriented

FORM_CLASS, _ = uic.loadUiType(
    os.path.join(os.path.dirname(__file__), "symbols_toolbox_dockwidget.ui")
)


class SymbolsToolboxDockWidget(QtWidgets.QDockWidget, FORM_CLASS):
    closingPlugin = pyqtSignal()

    def __init__(self, iface):
        """Constructor."""
        parent = None
        super(SymbolsToolboxDockWidget, self).__init__(parent)
        # Set up the user interface from Designer.
        # After setupUI you can access any designer object by doing
        # self.<objectname>, and you can use autoconnect slots - see
        # http://doc.qt.io/qt-5/designer-using-a-ui-file.html
        # #widgets-and-dialogs-with-auto-connect
        self.setupUi(self)

        self.iface = iface
        self.list_armoire = [
            "cde-ap",
            "cde-ex",
            "poste-ap",
            "poste-ex",
        ]
        self.list_divers = [
            "bj-ex",
            "coffb",
            "coffpc",
            "epbs22",
            "four2",
            "fc",
            "ptcoup",
            "repiq",
            "rmbt",
            "terre",
        ]
        self.list_foyer = [
            "ambi-ap",
            "ambi-apr",
            "ambi-ex",
            "ambi-exr",
            "borne-ap",
            "borne-apr",
            "borne-ex",
            "borne-exr",
            "fac-apr",
            "fac-ap",
            "fac-ex",
            "fac-exr",
            "fonc-ap",
            "fonc-ap1",
            "fonc-apr",
            "fonc-ex",
            "fonc-exr",
            "proj-ap",
            "proj-encap",
            "proj-ex",
            "proj-encex",
        ]
        self.list_support = [
            "pba",
            "pba-exo",
            "pbois-ap",
            "pbois-exo",
            "pbois-apr",
            "pbois-exr",
            "cand-ap",
            "cand-ex2",
            "cand-apr",
            "ptel",
        ]

        self.pushButtonFoyer_1.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/fonc-ap.svg"
            )
        )
        self.pushButtonFoyer_1.setToolTip("Fonctionnel à poser")
        self.pushButtonFoyer_1.setAccessibleName("fonc-ap")
        self.pushButtonFoyer_1.setEnabled(True)
        self.pushButtonFoyer_1.setVisible(True)
        self.pushButtonFoyer_1.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_2.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/fonc-ap1.svg"
            )
        )
        self.pushButtonFoyer_2.setToolTip("Fonctionnel à poser")
        self.pushButtonFoyer_2.setAccessibleName("fonc-ap1")
        self.pushButtonFoyer_2.setEnabled(True)
        self.pushButtonFoyer_2.setVisible(True)
        self.pushButtonFoyer_2.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_3.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/fonc-apr.svg"
            )
        )
        self.pushButtonFoyer_3.setToolTip("Fonctionnel à remplacer")
        self.pushButtonFoyer_3.setAccessibleName("fonc-apr")
        self.pushButtonFoyer_3.setEnabled(True)
        self.pushButtonFoyer_3.setVisible(True)
        self.pushButtonFoyer_3.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_4.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/fonc-ex.svg"
            )
        )
        self.pushButtonFoyer_4.setToolTip("Fonctionnel existant")
        self.pushButtonFoyer_4.setAccessibleName("fonc-ex")
        self.pushButtonFoyer_4.setEnabled(True)
        self.pushButtonFoyer_4.setVisible(True)
        self.pushButtonFoyer_4.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_5.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/fonc-exr.svg"
            )
        )
        self.pushButtonFoyer_5.setToolTip("Fonctionnel à poser")
        self.pushButtonFoyer_5.setAccessibleName("fonc-exr")
        self.pushButtonFoyer_5.setEnabled(True)
        self.pushButtonFoyer_5.setVisible(True)
        self.pushButtonFoyer_5.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_6.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/ambi-ap.svg"
            )
        )
        self.pushButtonFoyer_6.setToolTip("Ambiance à poser")
        self.pushButtonFoyer_6.setAccessibleName("ambi-ap")
        self.pushButtonFoyer_6.setEnabled(True)
        self.pushButtonFoyer_6.setVisible(True)
        self.pushButtonFoyer_6.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_7.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/ambi-apr.svg"
            )
        )
        self.pushButtonFoyer_7.setToolTip("Ambiance à remplacer")
        self.pushButtonFoyer_7.setAccessibleName("ambi-apr")
        self.pushButtonFoyer_7.setEnabled(True)
        self.pushButtonFoyer_7.setVisible(True)
        self.pushButtonFoyer_7.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_8.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/ambi-ex.svg"
            )
        )
        self.pushButtonFoyer_8.setToolTip("Ambiance existant")
        self.pushButtonFoyer_8.setAccessibleName("ambi-ex")
        self.pushButtonFoyer_8.setEnabled(True)
        self.pushButtonFoyer_8.setVisible(True)
        self.pushButtonFoyer_8.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_9.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/ambi-exr.svg"
            )
        )
        self.pushButtonFoyer_9.setToolTip("Fonctionnel existant")
        self.pushButtonFoyer_9.setAccessibleName("ambi-exr")
        self.pushButtonFoyer_9.setEnabled(True)
        self.pushButtonFoyer_9.setVisible(True)
        self.pushButtonFoyer_9.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_10.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/fac-ap.svg"
            )
        )
        self.pushButtonFoyer_10.setToolTip("Façade à poser")
        self.pushButtonFoyer_10.setAccessibleName("fac-ap")
        self.pushButtonFoyer_10.setEnabled(True)
        self.pushButtonFoyer_10.setVisible(True)
        self.pushButtonFoyer_10.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_11.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/fac-apr.svg"
            )
        )
        self.pushButtonFoyer_11.setToolTip("Façade à poser")
        self.pushButtonFoyer_11.setAccessibleName("fac-apr")
        self.pushButtonFoyer_11.setEnabled(True)
        self.pushButtonFoyer_11.setVisible(True)
        self.pushButtonFoyer_11.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_12.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/fac-ex.svg"
            )
        )
        self.pushButtonFoyer_12.setToolTip("Façade existant")
        self.pushButtonFoyer_12.setAccessibleName("fac-ex")
        self.pushButtonFoyer_12.setEnabled(True)
        self.pushButtonFoyer_12.setVisible(True)
        self.pushButtonFoyer_12.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_13.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/fac-exr.svg"
            )
        )
        self.pushButtonFoyer_13.setToolTip("Façade existant")
        self.pushButtonFoyer_13.setAccessibleName("fac-exr")
        self.pushButtonFoyer_13.setEnabled(True)
        self.pushButtonFoyer_13.setVisible(True)
        self.pushButtonFoyer_13.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_14.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/borne-ex.svg"
            )
        )
        self.pushButtonFoyer_14.setToolTip("Borne existante")
        self.pushButtonFoyer_14.setAccessibleName("borne-ex")
        self.pushButtonFoyer_14.setEnabled(True)
        self.pushButtonFoyer_14.setVisible(True)
        self.pushButtonFoyer_14.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_15.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/borne-exr.svg"
            )
        )
        self.pushButtonFoyer_15.setToolTip("Borne existante")
        self.pushButtonFoyer_15.setAccessibleName("borne-exr")
        self.pushButtonFoyer_15.setEnabled(True)
        self.pushButtonFoyer_15.setVisible(True)
        self.pushButtonFoyer_15.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_16.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/borne-ap.svg"
            )
        )
        self.pushButtonFoyer_16.setToolTip("Borne à placer")
        self.pushButtonFoyer_16.setAccessibleName("borne-ap")
        self.pushButtonFoyer_16.setEnabled(True)
        self.pushButtonFoyer_16.setVisible(True)
        self.pushButtonFoyer_16.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_17.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/borne-apr.svg"
            )
        )
        self.pushButtonFoyer_17.setToolTip("Borne à placer")
        self.pushButtonFoyer_17.setAccessibleName("borne-apr")
        self.pushButtonFoyer_17.setEnabled(True)
        self.pushButtonFoyer_17.setVisible(True)
        self.pushButtonFoyer_17.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_18.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/proj-ap.svg"
            )
        )
        self.pushButtonFoyer_18.setToolTip("Projecteur à placer")
        self.pushButtonFoyer_18.setAccessibleName("proj-ap")
        self.pushButtonFoyer_18.setEnabled(True)
        self.pushButtonFoyer_18.setVisible(True)
        self.pushButtonFoyer_18.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_19.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/proj-ex.svg"
            )
        )
        self.pushButtonFoyer_19.setToolTip("Projecteur existant")
        self.pushButtonFoyer_19.setAccessibleName("proj-ex")
        self.pushButtonFoyer_19.setEnabled(True)
        self.pushButtonFoyer_19.setVisible(True)
        self.pushButtonFoyer_19.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_20.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/proj-encap.svg"
            )
        )
        self.pushButtonFoyer_20.setToolTip("Projecteur encastré à placer")
        self.pushButtonFoyer_20.setAccessibleName("proj-encap")
        self.pushButtonFoyer_20.setEnabled(True)
        self.pushButtonFoyer_20.setVisible(True)
        self.pushButtonFoyer_20.clicked.connect(self.place_symbol)

        self.pushButtonFoyer_21.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/proj-encex.svg"
            )
        )
        self.pushButtonFoyer_21.setToolTip("Projecteur encastré existant")
        self.pushButtonFoyer_21.setAccessibleName("proj-encex")
        self.pushButtonFoyer_21.setEnabled(True)
        self.pushButtonFoyer_21.setVisible(True)
        self.pushButtonFoyer_21.clicked.connect(self.place_symbol)

        self.pushButtonSupport_1.setIcon(
            QIcon(":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/pba.svg")
        )
        self.pushButtonSupport_1.setToolTip("Poteau béton à poser")
        self.pushButtonSupport_1.setAccessibleName("pba")
        self.pushButtonSupport_1.setEnabled(True)
        self.pushButtonSupport_1.setVisible(True)
        self.pushButtonSupport_1.clicked.connect(self.place_symbol)

        self.pushButtonSupport_2.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/pba-exo.svg"
            )
        )
        self.pushButtonSupport_2.setToolTip("Poteau béton existant")
        self.pushButtonSupport_2.setAccessibleName("pba-exo")
        self.pushButtonSupport_2.setEnabled(True)
        self.pushButtonSupport_2.setVisible(True)
        self.pushButtonSupport_2.clicked.connect(self.place_symbol)

        self.pushButtonSupport_3.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/pbois-ap.svg"
            )
        )
        self.pushButtonSupport_3.setToolTip("Poteau bois à poser")
        self.pushButtonSupport_3.setAccessibleName("pbois-ap")
        self.pushButtonSupport_3.setEnabled(True)
        self.pushButtonSupport_3.setVisible(True)
        self.pushButtonSupport_3.clicked.connect(self.place_symbol)

        self.pushButtonSupport_4.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/pbois-exo.svg"
            )
        )
        self.pushButtonSupport_4.setToolTip("Poteau bois existant")
        self.pushButtonSupport_4.setAccessibleName("pbois-exo")
        self.pushButtonSupport_4.setEnabled(True)
        self.pushButtonSupport_4.setVisible(True)
        self.pushButtonSupport_4.clicked.connect(self.place_symbol)

        self.pushButtonSupport_5.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/cand-ap.svg"
            )
        )
        self.pushButtonSupport_5.setToolTip("Candélabre à poser")
        self.pushButtonSupport_5.setAccessibleName("cand-ap")
        self.pushButtonSupport_5.setEnabled(True)
        self.pushButtonSupport_5.setVisible(True)
        self.pushButtonSupport_5.clicked.connect(self.place_symbol)

        self.pushButtonSupport_6.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/cand-ex2.svg"
            )
        )
        self.pushButtonSupport_6.setToolTip("Candélabre existant")
        self.pushButtonSupport_6.setAccessibleName("cand-ex2")
        self.pushButtonSupport_6.setEnabled(True)
        self.pushButtonSupport_6.setVisible(True)
        self.pushButtonSupport_6.clicked.connect(self.place_symbol)

        self.pushButtonSupport_7.setIcon(
            QIcon(":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/ptel.svg")
        )
        self.pushButtonSupport_7.setToolTip("Poteau téléphonique")
        self.pushButtonSupport_7.setAccessibleName("ptel")
        self.pushButtonSupport_7.setEnabled(True)
        self.pushButtonSupport_7.setVisible(True)
        self.pushButtonSupport_7.clicked.connect(self.place_symbol)

        self.pushButtonArmoire_1.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/cde-ap.svg"
            )
        )
        self.pushButtonArmoire_1.setToolTip("Commande à poser")
        self.pushButtonArmoire_1.setAccessibleName("cde-ap")
        self.pushButtonArmoire_1.setEnabled(True)
        self.pushButtonArmoire_1.setVisible(True)
        self.pushButtonArmoire_1.clicked.connect(self.place_symbol)

        self.pushButtonArmoire_2.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/cde-ex.svg"
            )
        )
        self.pushButtonArmoire_2.setToolTip("Commande existante")
        self.pushButtonArmoire_2.setAccessibleName("cde-ex")
        self.pushButtonArmoire_2.setEnabled(True)
        self.pushButtonArmoire_2.setVisible(True)
        self.pushButtonArmoire_2.clicked.connect(self.place_symbol)

        self.pushButtonArmoire_3.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/poste-ap.svg"
            )
        )
        self.pushButtonArmoire_3.setToolTip("Poste à poser")
        self.pushButtonArmoire_3.setAccessibleName("poste-ap")
        self.pushButtonArmoire_3.setEnabled(True)
        self.pushButtonArmoire_3.setVisible(True)
        self.pushButtonArmoire_3.clicked.connect(self.place_symbol)

        self.pushButtonArmoire_4.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/poste-ex.svg"
            )
        )
        self.pushButtonArmoire_4.setToolTip("Poste existant")
        self.pushButtonArmoire_4.setAccessibleName("poste-ex")
        self.pushButtonArmoire_4.setEnabled(True)
        self.pushButtonArmoire_4.setVisible(True)
        self.pushButtonArmoire_4.clicked.connect(self.place_symbol)

        self.pushButtonDivers_1.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/coffb.svg"
            )
        )
        self.pushButtonDivers_1.setToolTip("Coffret B")
        self.pushButtonDivers_1.setAccessibleName("coffb")
        self.pushButtonDivers_1.setEnabled(True)
        self.pushButtonDivers_1.setVisible(True)
        self.pushButtonDivers_1.clicked.connect(self.place_symbol)

        self.pushButtonDivers_2.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/coffpc.svg"
            )
        )
        self.pushButtonDivers_2.setToolTip("Coffret prise de courant")
        self.pushButtonDivers_2.setAccessibleName("coffpc")
        self.pushButtonDivers_2.setEnabled(True)
        self.pushButtonDivers_2.setVisible(True)
        self.pushButtonDivers_2.clicked.connect(self.place_symbol)

        self.pushButtonDivers_3.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/epbs22.svg"
            )
        )
        self.pushButtonDivers_3.setToolTip("Coffret BS22 EP")
        self.pushButtonDivers_3.setAccessibleName("epbs22")
        self.pushButtonDivers_3.setEnabled(True)
        self.pushButtonDivers_3.setVisible(True)
        self.pushButtonDivers_3.clicked.connect(self.place_symbol)

        self.pushButtonDivers_4.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/four2.svg"
            )
        )
        self.pushButtonDivers_4.setToolTip("Fourreau")
        self.pushButtonDivers_4.setAccessibleName("four2")
        self.pushButtonDivers_4.setEnabled(True)
        self.pushButtonDivers_4.setVisible(True)
        self.pushButtonDivers_4.clicked.connect(self.place_symbol)

        self.pushButtonDivers_5.setIcon(
            QIcon(":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/fc.svg")
        )
        self.pushButtonDivers_5.setToolTip("fc")
        self.pushButtonDivers_5.setAccessibleName("fc")
        self.pushButtonDivers_5.setEnabled(True)
        self.pushButtonDivers_5.setVisible(True)
        self.pushButtonDivers_5.clicked.connect(self.place_symbol)

        self.pushButtonDivers_6.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/ptcoup.svg"
            )
        )
        self.pushButtonDivers_6.setToolTip("Coupure")
        self.pushButtonDivers_6.setAccessibleName("ptcoup")
        self.pushButtonDivers_6.setEnabled(True)
        self.pushButtonDivers_6.setVisible(True)
        self.pushButtonDivers_6.clicked.connect(self.place_symbol)

        self.pushButtonDivers_7.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/repiq.svg"
            )
        )
        self.pushButtonDivers_7.setToolTip("Repiquage")
        self.pushButtonDivers_7.setAccessibleName("repiq")
        self.pushButtonDivers_7.setEnabled(True)
        self.pushButtonDivers_7.setVisible(True)
        self.pushButtonDivers_7.clicked.connect(self.place_symbol)

        self.pushButtonDivers_8.setIcon(
            QIcon(":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/rmbt.svg")
        )
        self.pushButtonDivers_8.setToolTip("rmbt")
        self.pushButtonDivers_8.setAccessibleName("rmbt")
        self.pushButtonDivers_8.setEnabled(True)
        self.pushButtonDivers_8.setVisible(True)
        self.pushButtonDivers_8.clicked.connect(self.place_symbol)

        self.pushButtonDivers_9.setIcon(
            QIcon(
                ":/plugins/lumigis/resources/templates/projet-aps-sde22/svg/terre.svg"
            )
        )
        self.pushButtonDivers_9.setToolTip("Mise à la terre")
        self.pushButtonDivers_9.setAccessibleName("terre")
        self.pushButtonDivers_9.setEnabled(True)
        self.pushButtonDivers_9.setVisible(True)
        self.pushButtonDivers_9.clicked.connect(self.place_symbol)

    def place_symbol(self):
        obj = self.sender()
        if obj.accessibleName() in self.list_foyer:
            self.active_layer_by_name("foyer")
        elif obj.accessibleName() in self.list_support:
            self.active_layer_by_name("support")
        elif obj.accessibleName() in self.list_armoire:
            self.active_layer_by_name("armoire")
        elif obj.accessibleName() in self.list_divers:
            self.active_layer_by_name("divers")
        else:
            return
        self.point_tool = PlacePointOriented(
            self.iface,
            "point",
            coord_dimension=2,
            rot90=True,
            symbol=obj.accessibleName(),
        )
        self.point_tool.set_attr_values_dict(
            {
                "symbole": obj.accessibleName(),
            }
        )
        self.iface.mapCanvas().setMapTool(self.point_tool)
        global __lumigis_global__
        __lumigis_global__.event_filter.set_current_tool(self.point_tool)

    def closeEvent(self, event):
        self.closingPlugin.emit()
        event.accept()

    def active_layer_by_name(self, name):
        layers = QgsProject.instance().mapLayersByName(name)
        if len(layers) == 1:
            layer = layers[0]
            if layer is not None:
                self.iface.setActiveLayer(layer)
